#include "tap.h"

#define ID_FREESPACEPIE 0x807A10B4

#define	COLOR_CustomYellow	RGB(28,28,7)

TAP_ID (ID_FREESPACEPIE);
TAP_PROGRAM_NAME ("FreeSpaceBar 1.1b");
TAP_AUTHOR_NAME ("Marc (base code by Judy)");
TAP_DESCRIPTION ("Zeigt HD-Platz als Balken");
TAP_ETCINFO (__DATE__);

static int exitMenuShow = FALSE;					// stores state if in menu for exiting TAP
static TYPE_Window win;							// stores win-handle for exiting-menu
static int rgn;								// stores rgn-handle for exiting-menu
static int isPieDrawn = FALSE;						// stores flag for drawn pie
static int lastwf = -1;							// stores last position-value for redraw-evaluation
static int updatePie = FALSE;						// stores if we had to update bar
static byte *savedBox;							// stores last bar-bitmap
static byte *savedBox1;
static dword nextTick = 0;						// stores tick value for next update

#define COLOR_FRed   RGB( 23,  0, 0 )					// colors for bar (some currently unused)
#define COLOR_BRed   RGB( 15,  0, 0 )
#define COLOR_FGreen RGB(  0, 23, 0 )
#define COLOR_BGreen RGB(  0, 15, 0 )
#define COLOR_LGrey  RGB(8,8,8)
#define COLOR_MGrey  RGB(15,15,15)
#define COLOR_DGrey  RGB( 25, 25, 25)

#define ABS(x)	(((x)>0)?(x):(-(x)))

void DrawLine( word rgn, int Ax, int Ay, int Bx, int By, int Color )
{
	int dX = ABS(Bx-Ax);						// store the change in X and Y of the line endpoints
	int dY = ABS(By-Ay);

	int CurrentX = Ax;						// store the starting point (just point A)
	int CurrentY = Ay;

	int Xincr, Yincr;
	if (Ax > Bx) { Xincr=-1; } else { Xincr=1; }			// which direction in X?
	if (Ay > By) { Yincr=-1; } else { Yincr=1; }			// which direction in Y?

	if (dX >= dY)	// if X is the independent variable
	{
		int dPr 	= dY<<1;				// amount to increment decision if right is chosen (always)
		int dPru	= dPr - (dX<<1);			// amount to increment decision if up is chosen
		int P		= dPr - dX; 				// decision variable start value

		for (; dX>=0; dX--) 					// process each point in the line one at a time (just use dX)
		{
			TAP_Osd_PutPixel( rgn, CurrentX, CurrentY, Color);	// plot the pixel
			if (P > 0)								// is the pixel going right AND up?
			{
				CurrentX+=Xincr;			// increment independent variable
				CurrentY+=Yincr;			// increment dependent variable
				P+=dPru;				// increment decision (for up)
			}
			else						// is the pixel just going right?
			{
				CurrentX+=Xincr;			// increment independent variable
				P+=dPr; 				// increment decision (for right)
			}
		}
	}
	else			// if Y is the independent variable
	{
		int dPr 	= dX<<1;				// amount to increment decision if right is chosen (always)
		int dPru	= dPr - (dY<<1);			// amount to increment decision if up is chosen
		int P		= dPr - dY; 				// decision variable start value

		for (; dY>=0; dY--) 					// process each point in the line one at a time (just use dY)
		{

			TAP_Osd_PutPixel( rgn, CurrentX, CurrentY, Color);	// plot the pixel
			if (P > 0)						// is the pixel going up AND right?
			{
				CurrentX+=Xincr;			// increment dependent variable
				CurrentY+=Yincr;			// increment independent variable
				P+=dPru;				// increment decision (for up)
			}
			else						// is the pixel just going up?
			{
				CurrentY+=Yincr;			// increment independent variable
				P+=dPr; 				// increment decision (for right)
			}
		}
	}
}

void DrawPie (void)
{
	int w;								// counter for rows
	int wf;	                                                        // stores relative red/green transition position
    	int prc;							// stores free space percentage
	int rst;							// stores remaining recording time in seconds
	int mn;								// stores minute-part of remaining recording time
	int hr;								// stores hour-part of remaining recording time
	int x;								// currently unused
	int y;								// currently unused
	int lpos=109;							// stores left starting-position of bar
 	int sze=295;							// stores width of bar
	int tpos=460;
	int hgt=20;
	int toffset;
	int colmod=2;
	int cvalue=160;
	char str[40];							// temporary storage for text-outputs

	rgn = 0;							// tricky, hope it runs with newer firmware
	toffset=(hgt-20)/2;
	prc = TAP_Hdd_FreeSize()*100/TAP_Hdd_TotalSize();		// calculate percentage for free space
	rst = TAP_Hdd_FreeSize()/5*8;                                   // calculate remaining rec-time @ 5MBit in seconds
	hr = rst/60/60; 						// calculate remaining rec-time in hours
	mn = (rst-hr*60*60)/60;						// calculate remaining rec-time-minutes
        wf = sze-TAP_Hdd_FreeSize()*sze / TAP_Hdd_TotalSize();		// calculate relative position for red/green transition
	if (wf != lastwf)						// check if redraw is necessary
	{
		lastwf = wf;						// store last transition-value for redraw-check
		for ( w=0 ; w<hgt ; w++ )				// count w up for the 20 Lines of the bar 
		{	
			if (w<=hgt/2)					// check if we're drawing the upper or the lower half of the bar
				{
				cvalue=cvalue+colmod;
				DrawLine(rgn , lpos,tpos+w,lpos+wf,tpos+w,RGB(cvalue+7,0,0));		//Draw Red-Part of the bar, use line-value to change color
		     	DrawLine(rgn , lpos+wf,tpos+w,lpos+sze-1,tpos+w,COLOR_User4);      //Draw Green-Part of the bar, use line-value to change color
				}
			else
				{
				cvalue=cvalue-colmod;
				DrawLine(rgn , lpos,tpos+w,lpos+wf,tpos+w,RGB(cvalue+7,0,0));	//Draw Red-Part of the bar, use line-value to change color (inverted for lower half)
		     	DrawLine(rgn , lpos+wf,tpos+w,lpos+sze-1,tpos+w,COLOR_User4);	//Draw Green-Part of the bar, use line-value to change color (inverted for lower half)			
				}
		}
		for ( w=0 ; w<sze ; w+=4 )
		{
			DrawLine(rgn , lpos+w, tpos,lpos+w,tpos+hgt-1,COLOR_Black);
		}
		TAP_SPrint( str, "Rest: ~%02d:%02dh/5M",hr,mn);							//Format Text for free-percentage		
		TAP_Osd_PutStringAf1622( rgn, lpos+151, tpos-23,-1,str,COLOR_White, COLOR_User4 );
		DrawLine(rgn,lpos+wf,tpos,lpos+wf,tpos+hgt-1,RGB(255,255,255));
		TAP_Osd_Draw3dBox(rgn, lpos,tpos,sze,hgt,COLOR_LGrey,COLOR_DGrey); 			//Draw 3D-Box around Bar
		TAP_SPrint( str, "Frei: %02d%% (%02dGB/%02dGB)", prc,TAP_Hdd_FreeSize()/1024,TAP_Hdd_TotalSize()/1024);							//Format Text for free-percentage
		TAP_Osd_PutStringAf1419( rgn, lpos-1, tpos+toffset, -1, str, COLOR_Black, COLOR_None );		//Print black "framing" of next Text with...
		TAP_Osd_PutStringAf1419( rgn, lpos+1, tpos+toffset, -1, str, COLOR_Black, COLOR_None );		//... +1/-1 Offset to position
		TAP_Osd_PutStringAf1419( rgn, lpos, tpos+toffset, -1, str, COLOR_White, COLOR_None );		//Print free and total space-statement to bar
		savedBox1 = TAP_Osd_SaveBox( rgn, lpos+140,tpos-23,150,19);
		savedBox = TAP_Osd_SaveBox( rgn, lpos, tpos, sze, hgt+2);					//Store complete bar-area in buffer for fast redraw
	}
	else
		TAP_Osd_RestoreBox( rgn, lpos, tpos, sze, hgt+2, savedBox); // paint pie-bitmap from buffer	//Restore bar-area from buffer (as there were no changes)
		TAP_Osd_RestoreBox( rgn, lpos+140,tpos-23,150,19,savedBox1);
}

void ShowMessageWin (char* lpMessage, char* lpMessage1)
{
	int rgn;							// stores rgn-handle for osd
	dword w;							// stores width of message-text

	rgn = TAP_Osd_Create( 0, 0, 720, 576, 0, FALSE );		// create rgn-handle
	w = TAP_Osd_GetW( lpMessage, 0, FNT_Size_1926 ) + 10;		// calculate width of message
	if (TAP_Osd_GetW( lpMessage1, 0, FNT_Size_1926 ) + 10>w)
	{
		w = TAP_Osd_GetW( lpMessage1, 0, FNT_Size_1926 ) + 10;	// calculate width of message
	}
	if (w > 720) w = 720;						// if message is to long
	TAP_Osd_FillBox(rgn, (720-w)/2-5, 265, w+10, 62,		// draw background-box for border
			RGB(19,19,19) );
	TAP_Osd_PutS(rgn, (720-w)/2, 270, (720+w)/2, lpMessage,		// show message
		     RGB(31,31,31), RGB(3,5,10), 0, FNT_Size_1926,
		     FALSE, ALIGN_CENTER);
	TAP_Osd_PutS(rgn, (720-w)/2, 270+26, (720+w)/2, lpMessage1,		// show message
		     RGB(31,31,31), RGB(3,5,10), 0, FNT_Size_1926,
		     FALSE, ALIGN_CENTER);
	TAP_Delay(200);							// show it for 1.5 secounds
	TAP_Osd_Delete(rgn);						// release rgn-handle
}

void ShowExitMenuWin (char* lpTitle)
{
	dword w;							// stores width of title-text

	rgn = TAP_Osd_Create( 0, 0, 720, 576, 0, FALSE );		// create rgn-handle
	TAP_Win_SetDefaultColor( &win );				// use standard-color in win
	w = TAP_Osd_GetW( lpTitle, 0, FNT_Size_1622 ) + 15;		// calculate width of win
	TAP_Win_Create( &win, rgn, (720-w)/2, 253, w, 30,		// create win
			FALSE, FALSE );
	TAP_Win_SetTitle( &win, lpTitle, 0, FNT_Size_1622 );		// set title of win
	TAP_Win_AddItem( &win, "Ja" );					// add "Yes"-item
	TAP_Win_AddItem( &win, "Nein" );					// add "No"-item
	TAP_Win_SetSelection( &win, 1 );				// set "No"-item as default
}

int IsAnythingShown (void)
{
	TYPE_OsdBaseInfo osdBaseInfo;					// stores OSD-BaseInfo
	word *_vAddr[576];						// stores vertical addresses
	dword i;							// stores loop-variable for building addresses
	dword x;							// stores x-position for screen-scann
	dword y;							// stores y-position for screen-scann

	TAP_Osd_GetBaseInfo( &osdBaseInfo );				// get baseadresses of screen-buffer
	for( i=0; i<576; i+=2 )						// set vertical address
	{
		_vAddr[i] = osdBaseInfo.eAddr + 720*i;
		_vAddr[i+1] = osdBaseInfo.oAddr + 720*i;
	}
	for( y=0; y<576; y+=2 )						// scann entire screen-buffer
	{
		for ( x=0; x<720; x++ )
		{
			if ((*(_vAddr[y]+x)) != 0)			// if any value then graphics are shown
				return TRUE;				// return that somewhat is on the screen
		}
	}
	return FALSE;							// return that nothing is on screen
}

dword TAP_EventHandler (word wEvent, dword dwParam1, dword dwParam2)
{
	dword dwState, dwSubState;					// stores the states of firmware

	if (wEvent == EVT_IDLE)						// no key pressed, only idle-loop
	{
		TAP_GetState( &dwState, &dwSubState );			// get state of firmware
		if (isPieDrawn == TRUE)					// have we drawn the pie
		{
			if (dwState != STATE_FileList)			// has user exited filelist-mode
			{
				if (dwState == STATE_Normal)		// has user exited any menu
				{
					TAP_MemFree( savedBox );	// free saved pie-bitmap
					TAP_MemFree( savedBox1 );
					isPieDrawn = FALSE;		// erase flag

				}
			}
			ef (updatePie == TRUE)				// did we need to update pie
			{
				updatePie = FALSE;			// set flag
				DrawPie();				// update pie
			}
			ef (TAP_GetTick() >= nextTick)			// is it time to update
			{
				DrawPie();				// update pie
				nextTick = TAP_GetTick() + 100;		// set next tick-time to now + 1 secound
			}
		}
		else
		{
			if (dwState == STATE_FileList)			// are firmware in filelist-mode
			{
				isPieDrawn = TRUE;			// set flag
				DrawPie();				// draw the pie
			}
		}
	}
	ef (wEvent == EVT_KEY)						// has user pressed any key
	{
		TAP_GetState( &dwState, &dwSubState );			// get state of firmware
		if (isPieDrawn == TRUE)					// is pie shown
		{
			if (dwParam1 == RKEY_Ok	||			// has user pressed key
			    dwParam1 == RKEY_Rewind ||
			    dwParam1 == RKEY_Forward)			
				updatePie = TRUE;			// update pie in next idle-loop
		}
		if (dwState != STATE_Normal)				// skip if in any menu
			return dwParam1;				// passing unchanged keycode to firmware
		if (dwSubState != SUBSTATE_Normal)			// skip if in any sub-menu
			return dwParam1;				// passing unchanged keycode to firmware
		if (exitMenuShow == FALSE)				// test if TAP-exit-menu is not shown
		{
			if (dwParam1 == RKEY_Exit && 			// has user pressed Exit-key
			    IsAnythingShown() == FALSE)			// and nothing is on screen
			{
				exitMenuShow = TRUE;			// set exitMenuShow-Flag
				ShowExitMenuWin( "FreeSpaceBar verlassen ?");	// show Exit-Menu
				return 0;
			}
		}
		else							// TAP-exit-menu is shown
		{
			if (dwParam1 == RKEY_Ok)			// has user pressed OK
			{
				int selNum;				// stores selected menu-item

				selNum = TAP_Win_GetSelection( &win );	// get selection of exit-menu
				TAP_Win_Delete( &win );			// delete exit-menu win
				TAP_Osd_Delete( rgn );			// delete region-handle
				exitMenuShow = FALSE;			// set exitMenuShow-Flag
				if (selNum == 0)			// has user 'Yes' selected
				{
					TAP_Exit();			// stop TAP now
					return 0;
				}
				else
				{
					return RKEY_Exit;		// cascade Exit-key to other TAP's
				}
			}
			ef (dwParam1 == RKEY_Exit)			// has user pressed Exit 
			{
				TAP_Win_Delete( &win );			// delete exit-menu win
				TAP_Osd_Delete( rgn );			// delete region-handle
				exitMenuShow = FALSE;			// set exitMenuShow-Flag
				return 0;				// exit without Cascading
			}
			else						// user pressed any oher key
			{
				TAP_Win_Action( &win, dwParam1 );	// send all other key's to exit-menu-Win
				return 0;
			}

		}
	}
	return dwParam1; 						// passing unchanged state to firmware
}

int TAP_Main (void)
{
	ShowMessageWin("Marc's FreeSpacebar","wurde aktiviert" );	// show user TAP has started
	return 1;							// we're starting in TSR-mode
}
